## API Report File for "@genesislcap/foundation-entity-management"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import { ColDef } from '@ag-grid-community/core';
import { Connect } from '@genesislcap/foundation-comms';
import { Controller } from '@microsoft/fast-element';
import { DatasourceOptions } from '@genesislcap/foundation-comms';
import { ElementStyles } from '@microsoft/fast-element';
import { FASTElement } from '@microsoft/fast-element';
import { FoundationElement } from '@microsoft/fast-foundation';
import { FoundationElementRegistry } from '@microsoft/fast-foundation';
import { GridProRendererTypes } from '@genesislcap/grid-pro';
import { Logger } from '@genesislcap/foundation-utils';
import { OverrideFoundationElementDefinition } from '@microsoft/fast-foundation';
import { PartialFASTElementDefinition } from '@microsoft/fast-element';
import { ViewTemplate } from '@microsoft/fast-element';

// @public (undocumented)
export const buttonCellRenderer: (title: any, clickHandler: any) => {
    width: number;
    pinned: string;
    enableCellChangeFlash: boolean;
    cellStyle: {
        padding: string;
        lineHeight: string;
    };
    filter: boolean;
    suppressFiltersToolPanel: boolean;
    suppressColumnsToolPanel: boolean;
    headerName: string;
    minWidth: number;
    maxWidth: number;
    cellRendererSelector: (params: any) => {
        component: string;
        params: {
            actionClick: any;
            actionName: any;
            appearance: string;
        };
    };
};

// @public
export type DatasourceConfiguration = Omit<DatasourceOptions, 'resourceName' | 'request'>;

// Warning: (ae-forgotten-export) The symbol "EntityManagement_base" needs to be exported by the entry point index.d.ts
//
// @public
export class EntityManagement extends EntityManagement_base {
    // (undocumented)
    closeModal(): void;
    columns: ColDef[];
    protected connect: Connect;
    // @internal
    connectedCallback(): Promise<void>;
    create(): void;
    createEvent: string;
    // (undocumented)
    createFormUiSchema: any;
    // (undocumented)
    criteriaChanged(e: CustomEvent<string>): void;
    datasourceConfig: DatasourceConfiguration;
    deepClone(): Node;
    // (undocumented)
    defaultEntityValues: any;
    // @internal
    deleteEntity(e: CustomEvent): Promise<void>;
    deleteEvent: string;
    editDialogTitle: string;
    editedEntity: any;
    // (undocumented)
    editEntityModal: any;
    // (undocumented)
    editModalVisible: boolean;
    // (undocumented)
    editModalVisibleChanged(): void;
    // (undocumented)
    enableCellFlashing: boolean;
    // (undocumented)
    enableFilterBar: boolean;
    entityLabel: string;
    errorNotify(request: any): void;
    // @internal
    formResourceName: string;
    // (undocumented)
    formUiSchema: any;
    modalPosition: 'centre' | 'left' | 'right';
    persistColumnStateKey: string;
    // (undocumented)
    readEvent: string;
    // (undocumented)
    readEventFn: (...args: any[]) => {};
    // (undocumented)
    readonly: boolean;
    resourceName: string;
    selectedEntity: any;
    // (undocumented)
    sizeColumnsToFit: boolean;
    submitEntityChanges(e: CustomEvent): Promise<void>;
    // (undocumented)
    submitting: boolean;
    title: string;
    updateEvent: string;
    // (undocumented)
    updateFormUiSchema: any;
}

// @public
export const entityManagement: (overrideDefinition?: OverrideFoundationElementDefinition<    {
baseName: string;
template: ViewTemplate<EntityManagement, any>;
styles: ElementStyles;
shadowOptions: ShadowRootInit;
}>) => FoundationElementRegistry<    {
baseName: string;
template: ViewTemplate<EntityManagement, any>;
styles: ElementStyles;
shadowOptions: ShadowRootInit;
}, typeof EntityManagement>;

// @public
export const entityManagementShadowOptions: ShadowRootInit;

// @public
export const getErrorFormat: (err: any) => string;

// Warning: (ae-internal-missing-underscore) The name "logger" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal
export const logger: Logger;

// @public
export class Profiles extends EntityManagement {
    constructor();
    // (undocumented)
    deleteEntity(e: any): Promise<void>;
    // (undocumented)
    readProfileData(profile: any): Promise<{
        RIGHT_CODES: any[];
        USER_NAMES: any[];
        NAME: any;
    }>;
}

// Warning: (ae-forgotten-export) The symbol "Users_base" needs to be exported by the entry point index.d.ts
//
// @public
export class Users extends Users_base {
    constructor();
    // (undocumented)
    additionalCreateFields: any;
    // (undocumented)
    additionalUpdateFields: any;
    // (undocumented)
    allAccessType: boolean;
    // @internal
    availableEntitiesEndpoint: string;
    // @internal
    changeStatus(params: any): Promise<void>;
    columns: any;
    // (undocumented)
    connectedCallback(): Promise<void>;
    createEvent: string;
    // @internal
    datasourceConfig: DatasourceConfiguration;
    // (undocumented)
    deepClone(): Node;
    deleteEvent: string;
    // @internal
    entityColumn(): {
        headerName: string;
        field: string;
        enableCellChangeFlash: boolean;
        enableRowGroup: boolean;
        enablePivot: boolean;
        enableValue: boolean;
    }[];
    // @internal
    entityID: string;
    // @internal
    entityLabel: string;
    // @internal
    entityLabelKey: string;
    // @internal (undocumented)
    readUserData(user: any): Promise<{
        USER_PROFILES: any[];
        ADDRESS_LINE_1: any;
        ADDRESS_LINE_2: any;
        ADDRESS_LINE_3: any;
        ADDRESS_LINE_4: any;
        ACCESS_TYPE: string;
    } | {
        USER_PROFILES: any[];
        ADDRESS_LINE_1: any;
        ADDRESS_LINE_2: any;
        ADDRESS_LINE_3: any;
        ADDRESS_LINE_4: any;
        ACCESS_TYPE?: undefined;
    }>;
    // @internal
    resourceName: string;
    // @internal
    statusColumn(): {
        headerName: string;
        field: string;
        minWidth: number;
        width: number;
        suppressSizeToFit: boolean;
        cellRendererSelector: any;
        enableCellChangeFlash: boolean;
        enableRowGroup: boolean;
        enablePivot: boolean;
        enableValue: boolean;
    };
    // @internal
    statusRendererSelector(params: any): {
        component: GridProRendererTypes;
        params: {
            actionClick: () => Promise<void>;
            actionName: string;
            appearance: string;
        };
    };
    updateEvent: string;
}

// @public
export const UsersColumnConfig: ({
    field: string;
    headerName: string;
    enableCellChangeFlash: boolean;
    enableRowGroup: boolean;
    enablePivot: boolean;
    enableValue: boolean;
} | {
    field: string;
    headerName: string;
    valueFormatter: ({ value }: {
        value: any;
    }) => string;
    enableCellChangeFlash: boolean;
    enableRowGroup: boolean;
    enablePivot: boolean;
    enableValue: boolean;
})[];

// (No @packageDocumentation comment for this package)

```
